--########################################################################################
-- 
-- written by ChrisOHara  17.01.2023
-- This script is for free, no garantee -- use on own risk
--
-- the script is needs a dummy model where the first three cahnnel mixers do have to use searten setting
-- so certain special "magic numbers" can be read
--
-- mixer channel 01  - source TR01, switch LS01
-- mixer channel 02  - source Ch01, switch Tele
-- mixer channel 03  - source MAX
--
--
--########################################################################################


local indexSwitchLS01, indexSourceTR01, indexSourceMAX, indexSourceCH01, indexSwitchTele, indexSourceRud;
local radioType;


local function indexe_init ()

--    local inputData = { name, inputName, source, weight, offset, switch, curveType, curveValue, carryTrim, flightModes}
--    local switchData = { func, v1, v2, v3, and, delay, duration }
--    local custfuncData = { switch, func, name, value, mode, param, active}
--	inputData = model.getInput(0, 0 );
--	mixerData = model.getMix(channel, line);
--	switchData = model.getLogicalSwitch(0);
--	custfuncData = model.getCustomFunction(function-Number);


local ver, radio, maj, minor, rev, osname = getVersion();
	radioType = string.gsub(radio, "-simu", "")
	if radioType == nil then radioType = radio; end;


-- local mixerData = { name, source,  weight, offset, switch, multiplex, curveType, curveValue, flightModes, carryTrim, mixWarn, delayUp, delayDown, speedUp, speedDown}

	mixerData = model.getMix(0, 0);
	  indexSourceTR01 = mixerData.source;
	  indexSwitchLS01 = mixerData.switch;
	mixerData = model.getMix(1, 0);
	  indexSourceCH01 = mixerData.source;
	  indexSwitchTele = mixerData.switch;
	mixerData = model.getMix(2, 0);
	  indexSourceMAX = mixerData.source;

        inputData = model.getInput(0,0);
          indexSourceRud = inputData.source;

end

-- ############################### run function #####################

local function indexe_run(event)

	lcd.clear();
	lcd.drawText (0, 0,">"..radioType.."<", SMLSIZE);
	lcd.drawText (0, 9,"indexSwitchLS01 = "..indexSwitchLS01, SMLSIZE);
	lcd.drawText (0, 18,"indexSourceTR01 = "..indexSourceTR01, SMLSIZE);
	lcd.drawText (0, 27,"indexSourceMAX  = "..indexSourceMAX, SMLSIZE);
	lcd.drawText (0, 36,"indexSourceRud  = "..indexSourceRud, SMLSIZE);
	lcd.drawText (0, 45,"indexSourceCH01 = "..indexSourceCH01, SMLSIZE);
	lcd.drawText (0, 54,"indexSwitchTele = "..indexSwitchTele, SMLSIZE);

	return 0
end


return { init=indexe_init, run=indexe_run };